/***************************************************************************
 *   Copyright (C) 2008 by Oliver Groß                                     *
 *   z.o.gross@gmx.de                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef QCROSS_CGAMEWINDOW_H
#define QCROSS_CGAMEWINDOW_H

#include <QMainWindow>

namespace libqnono {
	class CNonogram;
	class CNonogramSolver;
}

namespace qcross {
	class CHighscore;
	class CCrossFieldWidget;
	
	/**
		@author Oliver Groß <z.o.gross@gmx.de>
	*/
	class CGameWindow : public QMainWindow {
		Q_OBJECT
	public:
		CGameWindow(QWidget * parent = 0);
		~CGameWindow();
		
	protected:
		libqnono::CNonogramSolver * m_Solver;
		
		CCrossFieldWidget * m_Field;
		libqnono::CNonogram * m_Picture;
		
		QString m_PackageName;
		int m_PictureIndex;
		CHighscore * m_Highscore;
		
		QAction * m_SaveGameAction;
		QAction * m_RestartGameAction;
		QAction * m_PauseGameAction;
		
		void createActions();
		
		bool readSaveGame(QDataStream & stream);
		void writeSaveGame(QDataStream & stream);
		
	protected slots:
		void newGame();
		
		void saveGame();
		void loadGame();
		
		void restartGame();
		void pauseGame(bool value);
		
		void wonGame();
		void lostGame();
		
		void handleErrorMark();
		
		void about();
		
		void startSolver();
	};
}

#endif
